// ConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "hwenctest.h"
#include "ConfigDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfigDlg dialog


CConfigDlg::CConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfigDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX, IDC_COMBO_DEVIDE, m_ComDevide);
	DDX_Control(pDX, IDC_COMBO_VIDEO, m_ComStandard);
	DDX_Control(pDX, IDC_COMBO_DISPLAY, m_ComDisplay);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CConfigDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_DEVIDE, OnSelchangeComboDevide)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigDlg message handlers

BOOL CConfigDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_ComDevide.AddString("1");
	m_ComDevide.AddString("4");
	m_ComDevide.AddString("9");
	m_ComDevide.AddString("16");
	m_ComDevide.SetCurSel(0);

	m_ComDisplay.AddString("Direct");
	m_ComDisplay.AddString("Timer");
	m_ComDisplay.SetCurSel(1);

	m_ComStandard.AddString("PAL");
	m_ComStandard.AddString("NTSC");
	m_ComStandard.SetCurSel(0);

	m_dwDevide = 1;
	m_bDirectDisplay = FALSE;
	m_dwStandard = 0;// PAL

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConfigDlg::OnSelchangeComboDevide() 
{
	// TODO: Add your control notification handler code here
	if ( 0 == m_ComDevide.GetCurSel() )
	{
		m_ComDisplay.EnableWindow(TRUE);
	}
	else
	{
		m_ComDisplay.EnableWindow(FALSE);
	}
}

void CConfigDlg::OnOK()
{
	// TODO: Add extra validation here
	DWORD dwRet = m_ComDevide.GetCurSel()+1;
	m_dwDevide = dwRet*dwRet;

	m_bDirectDisplay = m_ComDisplay.GetCurSel() == 0 ? TRUE : FALSE;
	m_dwStandard = m_ComStandard.GetCurSel();
	CDialog::OnOK();
}
