// HWEncTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HWEncTest.h"
#include "HWEncTestDlg.h"
#include "Mmsystem.h"
#include "SetDlgg.h"
#include "ConfigDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__; 
#endif

#include "HWEnc.h"
#include "HBPlaySDK.h"
#include "math.h"

#define MAX_DATA_BUFF	  704*576*2
#define TIME_OUT 10000
#define WM_ENDFILE WM_USER+100  
#define TREE_CONTRL_WIDTH 0

const CSize CHWEncTestDlg::m_CellSpace(1, 1);    
CHWEncTestDlg* g_pTestDlg = NULL;
extern CHWEncTestApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
DWORD	WINAPI  InputProc(void *lpvoid)
{
    CHWEncTestDlg	*pdlg = (CHWEncTestDlg *)lpvoid;
    
    pdlg->InputThread();
    
    return 0;
}

DWORD WINAPI ControlChannelProc(void* lpvoid)
{
	CHWEncTestDlg	*pdlg = (CHWEncTestDlg *)lpvoid;
	while ( 1 )
	{
		if ( pdlg->m_bChannelProc )
		{
			for ( int i=0; i<pdlg->m_nTotalPChannel; i++ )
			{
				HB15_CloseChannel(i);	
			}

			Sleep(5000);

			for ( i=0; i<pdlg->m_nTotalPChannel; i++ )
			{
				HB15_OpenChannel(i);
			}

			Sleep(5000);
		}
		else
		{
			Sleep(5000);
		}

	}

}

DWORD WINAPI InitCard(LPVOID pParam);
DWORD WINAPI InitCard(LPVOID pParam) //ͻ˳ʼ
{
	((CHWEncTestDlg*)pParam)->m_bCardInit = ((CHWEncTestDlg*)pParam)->InitCards();
	if(((CHWEncTestDlg*)pParam)->m_bCardInit)
	{
		((CHWEncTestDlg*)pParam)->m_InitCard.ShowWindow(SW_HIDE);
		return true;
	}
	else
	{
		
		CString str;
		str.LoadString(IDS_STRING_SETUP_CARD);
		((CHWEncTestDlg*)pParam)->EnableWindow();
		
		((CHWEncTestDlg*)pParam)->MessageBox(str,NULL,MB_OK);
		
		if(((CHWEncTestDlg*)pParam)->m_InitCardThread)
			CloseHandle(((CHWEncTestDlg*)pParam)->m_InitCardThread);
		
		((CHWEncTestDlg*)pParam)->m_InitCard.ShowWindow(SW_HIDE);
		return false;
	}
}

void	WINAPI fDecCBFun(long nChl, char* pBuf, long nSize,
            HB_FRAME_INFO* pFrameInfo, LPVOID pContext, long nReserved)
{	
    if ( OUT_FMT_YUV_420 == pFrameInfo->nType )    
    {       
        HB15_InputData(nChl, pBuf, pFrameInfo->nWidth, pFrameInfo->nHeight, CSP_YUV420);        
    }  
}

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHWEncTestDlg dialog

CHWEncTestDlg::CHWEncTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHWEncTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHWEncTestDlg)  
	m_bCyclePlay = TRUE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_InitCardThread = NULL;
	m_bCardInit = FALSE;
	
	g_pTestDlg = this;
	m_dwCurrentTV = 0;
    m_nTotalPChannel = 0;
    m_nTotalLChannel = 0;
    m_nDevideNum = 1;
    m_bInited = FALSE;
	for ( int i=0; i<MAX_PCHANNEL; i++ )    
	{
		m_dwCurrentDevNum[i] = 4;
	}
    memset(m_sH264File, 0, MAX_CELL_COUNT*255);
    memset(m_sYUVData, 0, 255);
    for ( i=0; i<MAX_CELL_COUNT; i++ )  
    {
        m_bOpened[i] = FALSE;
        m_hInputThread[i] = NULL;
    }
    for ( i=0; i<MAX_SERVER_NUM; i++ ) 
    {
        m_pNetDvrServer[i] = NULL; 
    }
    m_dwWidth = 352;
    m_dwHeight = 288;
    m_dwCurrentListNum = 0;
}

CHWEncTestDlg::~CHWEncTestDlg()
{
    g_pTestDlg = NULL;
}

void CHWEncTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHWEncTestDlg)
	DDX_Control(pDX, IDC_COMBO_YUVLIST, m_ComYUVList);
	DDX_Control(pDX, IDC_LIST_INFO, m_Cardlist);
	DDX_Control(pDX, IDC_LIST_CTRL, m_DeCardList);
	DDX_Control(pDX, IDC_PIC, m_InitCard);
	DDX_Check(pDX, IDC_CHECK_CYC, m_bCyclePlay);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHWEncTestDlg, CDialog)
	//{{AFX_MSG_MAP(CHWEncTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(NM_CLICK, IDC_LIST_CTRL, OnClickListCtrl)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_BUTTON_OPENFILE, OnButtonOpenfile)
	ON_BN_CLICKED(IDC_BUTTON_CLOSEFILE, OnButtonClosefile)
    ON_COMMAND_RANGE(ID_VIEW_CELL_1, ID_VIEW_CELL_16, OnRangeCell)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_FULL, OnButtonFull)
	ON_BN_CLICKED(IDC_BUTTON_OPENYUV, OnButtonOpenyuv)
	ON_BN_CLICKED(IDC_BUTTON_CLOSEYUV, OnButtonCloseyuv)
	ON_BN_CLICKED(IDC_RADIO_CIF, OnRadioCif)
	ON_BN_CLICKED(IDC_RADIO_D1, OnRadioD1)
	ON_BN_CLICKED(IDC_BUTTON_RESETPORT, OnButtonResetport)
	ON_BN_CLICKED(IDC_BUTTON_SET, OnButtonSet)
	ON_BN_CLICKED(IDC_RADIO_D2, OnRadio720)
	ON_BN_CLICKED(IDC_RADIO_QCIF, OnRadioQcif)
	ON_BN_CLICKED(IDC_BUTTON_CAHNNEL, OnButtonCahnnel)
	//}}AFX_MSG_MAP
    ON_MESSAGE(WM_ENDFILE, OnEndFile)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHWEncTestDlg message handlers

BOOL CHWEncTestDlg::OnInitDialog()
{
	CConfigDlg dlg;
	int nRet = dlg.DoModal();
	switch( nRet )
	{
	case IDCANCEL:
		OnCancel();
		break;

	case IDOK:
		m_nDevideNum = dlg.m_dwDevide;
		m_bDirectDisplay = dlg.m_bDirectDisplay;
		m_dwStandard = dlg.m_dwStandard;
		break;
	default:
		OnCancel();
		break;

	}

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
/*    m_nDevideNum = 4;*/
    int i=0,j=1;
    for ( i=0; i<MAX_PCHANNEL; i++ )
    {
        m_dwCurrentDevNum[i] = m_nDevideNum;  
	}

	i=j=1;

	while (j<=16)
	{
        BOOL bShow = (j<=m_nDevideNum)?TRUE:FALSE;
        GetDlgItem(ID_VIEW_CELL_0+j)->EnableWindow(bShow); 
		i++;
		j=i*i; 
	}
 	InitList();	
 	DWORD Card = 0; 
 	m_InitCardThread = CreateThread(NULL,0,LPTHREAD_START_ROUTINE(InitCard),this,0,&Card);			
//  WaitForSingleObject(m_InitCardThread, TIME_OUT);
//	OnRangeCell(ID_VIEW_CELL_0+m_nDevideNum);
	RefreshState(m_nDevideNum);
    char str[255];
    CheckDlgButton(IDC_RADIO_CIF,TRUE);
	m_ComYUVList.AddString("YUV420");
    m_ComYUVList.AddString("YUYV");
    m_ComYUVList.AddString("UYVY");
    m_ComYUVList.AddString("YV12");
    m_ComYUVList.AddString("UYVYD");
    m_ComYUVList.SetCurSel(0);

	m_dwWidth = 352;
    m_dwHeight = 288;
	CreateThread(NULL, 0, ControlChannelProc, this, 0, 0);
	m_bChannelProc = FALSE;

	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHWEncTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHWEncTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
    }  
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHWEncTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CHWEncTestDlg::OnOK() 
{
	// TODO: Add extra validation here
//	CDialog::OnOK();
}

bool CHWEncTestDlg::InitCards()
{
	//ǽʾͼƬ
	char strBkImage[255];
	char curDir[255];
    int i = 0;
	::GetCurrentDirectory(255,curDir);
	sprintf(strBkImage,"%s\\TV_BK.bmp",curDir);
 	HB15_SetTvOutBkImage(strBkImage);
 	HB15_SetMaxDevideNum( m_nDevideNum );
	HB15_SetDisplayMode( m_bDirectDisplay );
	HB15_SetVideoStandard( m_dwStandard );
	
	//ʼ뿨
	if (!HB15_InitCards()) 
	{
		CString str;
		str.LoadString(IDS_STRING_INITCARD_FAILED);
		if(m_bCardInit)
		{
			AfxMessageBox(str);
		}
		return false;
	}
	
	m_nTotalPChannel = HB15_GetChannels();
    m_nTotalLChannel = m_nTotalPChannel*m_nDevideNum;

    m_dwDSPNum = HB15_GetDSPs();
    m_Cardlist.InsertColumn(0, "");
    m_Cardlist.InsertColumn(1, "Card Info");
    m_Cardlist.InsertColumn(2, "Slot Type");
    m_Cardlist.SetColumnWidth(0, 40);
    m_Cardlist.SetColumnWidth(1, 150);
    m_Cardlist.SetColumnWidth(2, 80);
    
    for ( i=0; i<m_dwDSPNum; i++) 
    {
        DWORD type, serial;
        char sInfo[100];
        sprintf(sInfo, "%d", i+1);
        m_Cardlist.InsertItem(i+1,"11");
        m_Cardlist.SetItemText(i, 0, sInfo);
        HB15_GetBoardInfo(i, &type, &serial);        
        sprintf(sInfo, "%x  %08d", type, serial);
        m_Cardlist.SetItemText(i, 1, sInfo);       
        if ( HB15_GetPCIType(i*2) == 1)
        {
            m_Cardlist.SetItemText(i,2,"PCI");
        }
        else if (HB15_GetPCIType(i*2) == 2)
        {
            m_Cardlist.SetItemText(i,2,"PCI-E");
      	}
	}
	
	for (int nChl = 0; nChl < m_nTotalLChannel; nChl++) 
	{
		HB15_OpenLogicChannel(nChl);	
	}
	
	CString str,strTemp;
	for( i = 0; i< m_nTotalPChannel; i++ )
	{
        strTemp.Format("%d",i+1);
		str.LoadString(IDS_STRING_STAKEOUT);
        str += strTemp;
		m_DeCardList.InsertItem(i, str);	
	}
    OnRangeCell(ID_VIEW_CELL_0+m_nDevideNum);  
    m_bInited = TRUE;

	//HB15_SetUnderScan(0, 0, 0, 0);
	return true;
}

void CHWEncTestDlg::InitList()
{
	m_ImageListTV.Create(64, 64, ILC_COLORDDB|ILC_MASK, 2, 2);
	m_ImageListTV.Add(AfxGetApp()->LoadIcon(IDI_ICON_TV));
	m_DeCardList.SetImageList(&m_ImageListTV,LVSIL_NORMAL);
	m_DeCardList.SetBkColor(RGB(50,50,50));
	m_DeCardList.SetTextBkColor(RGB(50,50,50));
	m_DeCardList.SetTextColor(RGB(244,244,245));
}

void CHWEncTestDlg::OnClickListCtrl(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	POSITION pos;
	int nTemp=-1;
	pos=m_DeCardList.GetFirstSelectedItemPosition();
	nTemp= m_DeCardList.GetNextSelectedItem(pos);
	if ( nTemp<0 )
	{
		return;
	}
	m_dwCurrentTV = nTemp;
	m_nStartCell = m_dwCurrentTV*m_nDevideNum;
//	UINT nID = m_dwCurrentDevNum[m_dwCurrentTV]+ID_VIEW_CELL_0;
	m_nRow = m_nColumn = (int)sqrt(m_dwCurrentDevNum[m_dwCurrentTV]);
	CRect rcCell[MAX_CELL_COUNT];
	PartitionRect( rcCell, m_nRow, m_nColumn, NULL, 0 );
    LayoutCellWnd( m_nStartCell, rcCell, m_nRow, m_nColumn );
	RefreshState(m_dwCurrentDevNum[m_dwCurrentTV]);
//	*pResult = 0;
}

void CHWEncTestDlg::RefreshState(DWORD dwDevideNum)
{
	//óɲͬͼ
	int i=1,j=1;
	while (j<=16)
	{
		CheckDlgButton(ID_VIEW_CELL_0+j,(dwDevideNum==j)?TRUE:FALSE);
		i++;
		j=i*i;
	}
}

int CHWEncTestDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)  
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
    // Create cell window.
    int i;
    for ( i = 0; i < MAX_CELL_COUNT; i++ )
    {
        m_CellWnd[i].m_nIndex = i;
        VERIFY(m_CellWnd[i].CreateEx( 0, CELL_WINDOW_CLASS, NULL,
            WS_CHILD | WS_CLIPCHILDREN, CRect(0,0,0,0), this, 0 ));
    }
    m_nRow = 1;
    m_nColumn = 1;
    m_nStartCell = 0;
    m_CellWnd[0].Active();
	
    // Create full screen window.
    VERIFY(m_FullScreenWnd.CreateEx( 0, CELL_WINDOW_CLASS, NULL,
        WS_POPUP, CRect(0,0,0,0), this, 0 ));
	return 0;
}

BOOL CHWEncTestDlg::PartitionRect( OUT LPRECT prcCell, int nRow, int nColumn,
							   OUT LPRECT prcPlayCtrl, int nPlayCtrlHeight )
{
    // Client rectangle.
    CRect rcClient;  
    GetClientRect( rcClient );
	
    // Partition play control.
    CRect rcPlayCtrl = rcClient;
	rcPlayCtrl.left=0;
	rcPlayCtrl.right=704;
	rcPlayCtrl.bottom=576;
	rcPlayCtrl.top=0;
    if ( prcPlayCtrl )
    {
        CopyRect( prcPlayCtrl, rcPlayCtrl );
    }
	
	
    if ( prcCell
        && nRow >= 1
        && nColumn >= 1 )
    {
        // Cell size
        CRect rcTotalCell = rcPlayCtrl;//rcClient;               // Total cell rectangle.
 //       rcTotalCell.bottom = rcPlayCtrl.top;
        double x = double(rcTotalCell.Width() - (nRow - 1) * m_CellSpace.cx) / nRow;
        double y = double(rcTotalCell.Height() - (nColumn - 1) * m_CellSpace.cy) / nColumn;
        CSize CellSize;
        CellSize.cx = int(x);
        CellSize.cy = int(y);
		
        // Cell rectangle
        CPoint pt;
        int i, j, k;
        for ( i = 0, k = 0; i < nRow; i++ )
        {
            pt.y = i * (CellSize.cy + m_CellSpace.cy);
			
            for ( j = 0; j < nColumn; j++, k++ )
            {
                pt.x = j * (CellSize.cx + m_CellSpace.cx);
				
                prcCell[k].left   = pt.x+TREE_CONTRL_WIDTH;
                prcCell[k].right  = pt.x + CellSize.cx+TREE_CONTRL_WIDTH;
                prcCell[k].top    = pt.y;
                prcCell[k].bottom = pt.y + CellSize.cy;
            }
        }
    }
	
    return TRUE;
}

BOOL CHWEncTestDlg::LayoutCellWnd( int nStartCell, IN LPCRECT prcCell,
							   int nRow, int nColumn )
{
    ASSERT(nStartCell >= 0 && nStartCell < MAX_CELL_COUNT);
    ASSERT(prcCell);
    if ( nStartCell < 0
        || nStartCell >= MAX_CELL_COUNT
        || NULL == prcCell )
    {
        return FALSE;
    }
	
    HDWP hCellPos = BeginDeferWindowPos( MAX_CELL_COUNT );
    if ( hCellPos )
    {
        // Hide cell window
        int n;
        for ( n = 0; n < nStartCell && n < MAX_CELL_COUNT && hCellPos; n++ )
        {
            hCellPos = DeferWindowPos( hCellPos,
                m_CellWnd[n].GetSafeHwnd(),
                NULL,
                0, 0, 0, 0,
                SWP_NOZORDER | SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW );
            ASSERT(hCellPos);
        }
		
        // Layout cell window
        int i, j, k;
        for ( i = 0, k = 0; i < m_nRow; i++ )
        {
            for ( j = 0; j < m_nColumn && n < MAX_CELL_COUNT && hCellPos; j++, k++, n++ )
            {
                hCellPos = DeferWindowPos( hCellPos,
                    m_CellWnd[n].GetSafeHwnd(),
                    NULL,
                    prcCell[k].left,
                    prcCell[k].top,
                    prcCell[k].right - prcCell[k].left,
                    prcCell[k].bottom - prcCell[k].top,
                    SWP_NOZORDER | SWP_SHOWWINDOW );
                ASSERT(hCellPos);
            }
        }
		
        // Hide cell window
        for ( ; n < MAX_CELL_COUNT && hCellPos; n++ )
        {
            hCellPos = DeferWindowPos( hCellPos,
                m_CellWnd[n].GetSafeHwnd(),
                NULL,
                0, 0, 0, 0,
                SWP_NOZORDER | SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW );
            ASSERT(hCellPos);
        }
		
        EndDeferWindowPos( hCellPos );
    }
	
    return TRUE;
}

void CHWEncTestDlg::OnRangeCell(UINT nID)
{
    // TODO: Add your command handler code here
	m_dwCurrentDevNum[m_dwCurrentTV] = nID-ID_VIEW_CELL_0;
    switch ( nID )
    {
		case ID_VIEW_CELL_1:
		         m_nRow    = 1;
		         m_nColumn = 1;
		         break;
		 
		     case ID_VIEW_CELL_4:
		         m_nRow    = 2;
		         m_nColumn = 2;
		         break;
		 
		     case ID_VIEW_CELL_9:
		         m_nRow    = 3;
		         m_nColumn = 3;
		         break;
		 
		    case ID_VIEW_CELL_16:
		         m_nRow    = 4;
		        m_nColumn = 4;
		         break;		 
		     default:
		         ASSERT(FALSE);
		         break;
    }
	
    // Layout cell window.
	CRect rcCell[MAX_CELL_COUNT];
	PartitionRect( rcCell, m_nRow, m_nColumn, NULL, 0 );
	LayoutCellWnd( m_nStartCell, rcCell, m_nRow, m_nColumn );
    if ( m_bInited )
    {
        HB15_SetOutPutChlDevideNum(m_dwCurrentTV, m_dwCurrentDevNum[m_dwCurrentTV]);
    }
}

void CHWEncTestDlg::OnButtonOpenfile() 
{
	// TODO: Add your control notification handler code here
	static char BASED_CODE szFilter[] = 
		"(*.264)|*.264|All Files (*.*)|*.*||"; 
	CFileDialog dlgFileOpen( true ,
		NULL ,
							 NULL , 
							 OFN_HIDEREADONLY,
							 szFilter ,
							 this );
	CCellWnd*pCellWnd = GetActiveCellWnd();
	DWORD nChl = CCellWnd::sm_nActiveIndex;
	HB15_OpenLogicChannel(nChl);
	if (dlgFileOpen.DoModal()==IDOK) 
	{	
		strcpy(m_sH264File[nChl], (LPSTR)(LPCSTR)dlgFileOpen.GetPathName());
		if (strlen(m_sH264File[nChl])) 
		{			
			HB_PLAY_OpenFile(nChl,	m_sH264File[nChl]);
            HB_PLAY_SetFileEndMsg(nChl, m_hWnd, WM_ENDFILE);
			HB_PLAY_SetDecCallBack(nChl, fDecCBFun, OUT_FMT_YUV_420);
			HB_PLAY_Play(nChl, pCellWnd->m_VideoWnd.GetSafeHwnd());			
		}			
	}	
}

void CHWEncTestDlg::OnButtonClosefile() 
{
	// TODO: Add your control notification handler code here
	DWORD nChl = CCellWnd::sm_nActiveIndex;
	CCellWnd*pCellWnd = GetActiveCellWnd();
	HB_PLAY_CloseFile(nChl);
//    HB15_ShowBkImage(nChl);
	HB15_CloseLogicChannel(nChl);
	pCellWnd->m_VideoWnd.Invalidate();
}

void CHWEncTestDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
    for (int i=0; i<m_nTotalLChannel; i++)
    {
        HB15_CloseLogicChannel(i);
    }
	HB15_ReleaseCards();
	CDialog::OnCancel();
}

void CHWEncTestDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	
}

void CHWEncTestDlg::OnButtonFull() 
{
	// TODO: Add your control notification handler code here
    DWORD nChl = CCellWnd::sm_nActiveIndex;
    HB15_SetInputChlFullMode(nChl, TRUE);
    m_dwCurrentDevNum[m_dwCurrentTV] = 1;
    RefreshState(1);
    CRect rcCell;
    rcCell.left = 0+TREE_CONTRL_WIDTH;//0+10;
    rcCell.top = 0;
    rcCell.right = 704+TREE_CONTRL_WIDTH;//704+10;
    rcCell.bottom = 576;
    LayoutCellWnd( nChl, rcCell, 1, 1 );
}

void CHWEncTestDlg::OnEndFile(WPARAM wParam, LPARAM lParam)
{
    DWORD nChl = (DWORD)wParam;
    if(!((CButton *)GetDlgItem(IDC_CHECK_CYC))->GetCheck())
    {
        HB_PLAY_CloseFile(nChl);						
    }
    else
    {
        HB_PLAY_CloseFile(nChl);
        HB_PLAY_OpenFile(nChl, m_sH264File[nChl]);
        HB_PLAY_SetFileEndMsg(nChl, m_hWnd, WM_ENDFILE);
        HB_PLAY_SetDecCallBack(nChl, fDecCBFun, 1);
        HB_PLAY_Play(nChl, m_CellWnd[nChl].m_VideoWnd.GetSafeHwnd());
    }

} 

void CHWEncTestDlg::OnButtonOpenyuv() 
{
	// TODO: Add your control notification handler code here
    static char BASED_CODE szFilter[] = 
        "Raw Data files (*.yuv;*.dat)|*.yuv;*.dat|All Files (*.*)|*.*||"; 
    
    CFileDialog dlgFileOpen( true ,
							 NULL ,
                             NULL , 
                             OFN_HIDEREADONLY,
                             szFilter,
                             this );
    char	sFile[255];
    memset(sFile, 0, sizeof(sFile));
    if (dlgFileOpen.DoModal()==IDOK) 
    {	
        strcpy(m_sYUVData, (LPSTR)(LPCSTR)dlgFileOpen.GetPathName());
        CCellWnd*pCellWnd = GetActiveCellWnd();
        DWORD nChl = CCellWnd::sm_nActiveIndex;
        m_bOpened[nChl] = TRUE;
		HB15_OpenLogicChannel(nChl);

        if ( !m_hInputThread[nChl] ) 
        {			
            m_hInputThread[nChl] = CreateThread(NULL, 0, InputProc, this, 0, NULL);
	    }
	}
}

void CHWEncTestDlg::OnButtonCloseyuv() 
{
	// TODO: Add your control notification handler code here
	DWORD nChl = CCellWnd::sm_nActiveIndex;
    m_bOpened[nChl] = FALSE;
    Sleep(50);
    CloseHandle(m_hInputThread[nChl]);
    m_hInputThread[nChl] = NULL;
    //HB15_ShowBkImage(nChl);
	HB15_CloseLogicChannel(nChl);
}

void CHWEncTestDlg::InputThread()
{	
    DWORD nRet;
    FILE *fpRead = fopen(m_sYUVData, "rb");
    memset(m_sYUVData, 0, 255);
    DWORD nChl = CCellWnd::sm_nActiveIndex;

    if (!fpRead)	return;
    char *pDataSrc = new char[MAX_DATA_BUFF];
    
    DWORD dwTime;
    DWORD dwNum=0;
    DWORD dwStart = 0;
    DWORD dwEnd = 0;
    FLOAT fSize = 3.0/2;
    DWORD dwWidth = m_dwWidth;
    DWORD dwHeight = m_dwHeight;
    int colorspace = m_ComYUVList.GetCurSel()+1;

    switch (colorspace)
    {
    case CSP_YUV420:
    case CSP_YV12:
        fSize = 3.0/2;
        break;
    case CSP_YUV422_UYVY:
    case CSP_YUV422_YUYV:
    case CSP_YUV422_UYVYD:
        fSize = 2.0;
        break;
    default:
        fSize = 3.0/2;
        break;
    }

	BOOL bSuc = false;
	CString str;
    dwTime = timeGetTime();
    while ( m_bOpened[nChl] ) 
    {	
        if ( (timeGetTime()-dwTime) >= 40)//35 
            
        {
            
            nRet = fread(pDataSrc, sizeof(pDataSrc[0]), DWORD(fSize*dwWidth*dwHeight), fpRead);
                   
            if( nRet == DWORD(dwWidth*dwHeight*fSize) )
            {                
                bSuc = HB15_InputData(nChl, pDataSrc, dwWidth, dwHeight, colorspace);
				if ( !bSuc )
				{
					str.Format("chl = %d, return false.", nChl);
					OutputDebugString(str);
				}
            }
            else
            {
                fseek(fpRead, 0, SEEK_SET);
                //nRet = fread(pDataSrc, sizeof(pDataSrc[0]), DWORD(fSize*dwWidth*dwHeight), fpRead);
		    }
            dwTime = timeGetTime();          
        }
        Sleep(1);
    }
    
    delete []pDataSrc;
    pDataSrc = NULL;
    
    fclose(fpRead);
}

void CHWEncTestDlg::OnRadioCif() 
{
	// TODO: Add your control notification handler code here
	m_dwWidth = 352;
    m_dwHeight = 288;
}

void CHWEncTestDlg::OnRadioD1() 
{
	// TODO: Add your control notification handler code here
    m_dwWidth = 704;
    m_dwHeight = 576;
}

void CHWEncTestDlg::OnButtonResetport() 
{
	// TODO: Add your control notification handler code here
	HB15_ResetVideoPort(m_dwCurrentTV);
}

void CHWEncTestDlg::OnButtonSet() 
{
	// TODO: Add your control notification handler code here
// 	CSetDlgg dlg;
// 	dlg.DoModal();
}

void CHWEncTestDlg::OnRadio720() 
{
	// TODO: Add your control notification handler code here
	m_dwWidth = 720;
    m_dwHeight = 576;
}

void CHWEncTestDlg::OnRadioQcif() 
{
	// TODO: Add your control notification handler code here  
	m_dwWidth = 176;
    m_dwHeight = 144;
}

void CHWEncTestDlg::OnButtonCahnnel() 
{
	// TODO: Add your control notification handler code here

	m_bChannelProc = !m_bChannelProc;
}
